/* fileCopy.c
 * Demonstrate text file I/O by copying one file
 * to another.
 * The program also uses command line arguments.
 */
#include <stdio.h>
#include <stdlib.h>

void copy(FILE* in, FILE* out);

int main(int argc, char* argv[]) {
  FILE* in_file;
  FILE* out_file;

  if (argc != 3) {
    printf("Usage: fileCopy input output\n");
    exit(1);
  }
  
  in_file = fopen(argv[1], "r");
  if (in_file == NULL) {
    fprintf(stderr,
        "ERROR: couldn't open %s for reading\n",
        argv[1]);
    exit(1);
  }

  out_file = fopen(argv[2], "w");
  if (out_file == NULL) {
    fprintf(stderr,
        "ERROR: couldn't open %s for writing\n",
        argv[2]);
    exit(1);
  }

  copy(in_file, out_file);

  return 0;
}

#define BUF_SIZE 200

void copy(FILE* in, FILE* out) {
  char buffer[BUF_SIZE];

  while (fgets(buffer, BUF_SIZE, in) != NULL)
    fprintf(out, "%s", buffer);
}
